package com.terraformersmc.terrestria.biome;

import com.terraformersmc.terrestria.biome.builder.TerrestriaBiome;
import com.terraformersmc.terrestria.init.TerrestriaBiomes;
import com.terraformersmc.terrestria.init.TerrestriaFeatures;
import net.minecraft.class_1299;
import net.minecraft.class_1959;
import net.minecraft.class_2246;
import net.minecraft.class_2893;
import net.minecraft.class_2998;
import net.minecraft.class_3031;
import net.minecraft.class_3037;
import net.minecraft.class_3098;
import net.minecraft.class_3101;
import net.minecraft.class_3163;
import net.minecraft.class_3273;
import net.minecraft.class_3284;
import net.minecraft.class_3523;
import net.minecraft.world.gen.feature.*;

import static com.terraformersmc.terrestria.biome.builder.DefaultFeature.*;
import static com.terraformersmc.terrestria.biome.builder.DefaultFeature.DESERT_VEGETATION;

public class CypressSwampBiomes {
	public static void register() {
		TerrestriaBiomes.CYPRESS_SWAMP = TerrestriaBiomes.register("cypress_swamp", TerrestriaBiome.builder()
				.configureSurfaceBuilder(class_3523.field_15681, class_3523.field_15677)
				.precipitation(class_1959.class_1963.field_9382).category(class_1959.class_1961.field_9364)
				.depth(-0.25F)
				.scale(0.05F)
				.temperature(0.7F)
				.downfall(0.7F)
				.waterColor(0x2c7f32)
				.waterFogColor(0x053305)
				.addDefaultFeatures(LAND_CARVERS, STRUCTURES, LAKES, DUNGEONS, MINEABLES, ORES, CLAY, DEFAULT_GRASS,
						DEFAULT_MUSHROOMS, SPRINGS, SEAGRASS, MORE_SEAGRASS, FOSSILS, FROZEN_TOP_LAYER, SWAMP_VEGETATION,
						DESERT_VEGETATION)
				.addTreeFeature(TerrestriaFeatures.MEGA_CYPRESS_TREE, 2)
				.addTreeFeature(TerrestriaFeatures.RUBBER_TREE, 3)
				.addTreeFeature(TerrestriaFeatures.WILLOW_TREE, 1)
				.addCustomFeature(class_2893.class_2895.field_13178, class_1959.method_8699(
						TerrestriaFeatures.CATTAIL, new class_3163(80, 0.3D),
						class_3284.field_14231, class_2998.field_13436))
				.addCustomFeature(class_2893.class_2895.field_13178, class_1959.method_8699(
						class_3031.field_13542, class_3037.field_13603, class_3284.field_14240, new class_3273(32)))
				.addGrassFeature(class_2246.field_10479.method_9564(), 2)
				.addGrassFeature(class_2246.field_10251.method_9564(), 1)
				.addDoubleGrassFeature(class_2246.field_10214.method_9564(), 1)
				.addStructureFeature(class_3031.field_13565)
				.addStructureFeature(class_3031.field_13547, new class_3101(0.004D, class_3098.class_3100.field_13692))
				.addDefaultSpawnEntries()
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6070, 8, 2, 4))
				.build());
	}
}
