package com.terraformersmc.terrestria.biome;

import com.terraformersmc.terrestria.biome.builder.TerrestriaBiome;
import com.terraformersmc.terrestria.init.TerrestriaBiomes;
import com.terraformersmc.terrestria.init.TerrestriaFeatures;
import net.minecraft.class_1299;
import net.minecraft.class_1959;
import net.minecraft.class_3031;
import net.minecraft.class_3098;
import net.minecraft.class_3101;
import net.minecraft.class_3523;

import static com.terraformersmc.terrestria.biome.builder.DefaultFeature.*;
import static com.terraformersmc.terrestria.biome.builder.DefaultFeature.FOREST_GRASS;

public class JapaneseMapleForestBiomes {
	public static void register() {
		TerrestriaBiomes.JAPANESE_MAPLE_FOREST = TerrestriaBiomes.register("japanese_maple_forest", TerrestriaBiome.builder()
				.configureSurfaceBuilder(class_3523.field_15701, class_3523.field_15677)
				.precipitation(class_1959.class_1963.field_9382).category(class_1959.class_1961.field_9370)
				.depth(0.05F)
				.scale(0.2F)
				.temperature(0.8F)
				.downfall(0.5F)
				.waterColor(4159204)
				.waterFogColor(329011)
				.addDefaultFeatures(LAND_CARVERS, STRUCTURES, LAKES, DUNGEONS, MINEABLES, ORES, DEFAULT_MUSHROOMS,
						DEFAULT_VEGETATION, SPRINGS, FROZEN_TOP_LAYER, FOREST_GRASS)
				.addStructureFeature(class_3031.field_13565)
				.addStructureFeature(class_3031.field_13547, new class_3101(0.004D, class_3098.class_3100.field_13692))
				.addTreeFeature(TerrestriaFeatures.JAPANESE_MAPLE_TREE, 3)
				.addTreeFeature(TerrestriaFeatures.JAPANESE_MAPLE_SHRUB, 3)
				.addTreeFeature(TerrestriaFeatures.DARK_JAPANESE_MAPLE_TREE, 3)
				.addDefaultSpawnEntries()
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6055, 5, 4, 4))
				.build());

		TerrestriaBiomes.WOODED_JAPANESE_MAPLE_HILLS = TerrestriaBiomes.register("wooded_japanese_maple_hills", TerrestriaBiome.builder()
				.configureSurfaceBuilder(class_3523.field_15701, class_3523.field_15677)
				.precipitation(class_1959.class_1963.field_9382).category(class_1959.class_1961.field_9370)
				.depth(0.45F)
				.scale(0.5F)
				.temperature(0.8F)
				.downfall(0.5F)
				.waterColor(4159204)
				.waterFogColor(329011)
				.addDefaultFeatures(LAND_CARVERS, STRUCTURES, LAKES, DUNGEONS, MINEABLES, ORES, DEFAULT_MUSHROOMS,
						DEFAULT_VEGETATION, SPRINGS, FROZEN_TOP_LAYER, FOREST_GRASS)
				.addStructureFeature(class_3031.field_13565)
				.addStructureFeature(class_3031.field_13547, new class_3101(0.004D, class_3098.class_3100.field_13692))
				.addTreeFeature(TerrestriaFeatures.JAPANESE_MAPLE_TREE, 3)
				.addTreeFeature(TerrestriaFeatures.JAPANESE_MAPLE_SHRUB, 3)
				.addTreeFeature(TerrestriaFeatures.DARK_JAPANESE_MAPLE_TREE, 3)
				.addDefaultSpawnEntries()
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6055, 5, 4, 4))
				.build());
	}
}
