package com.terraformersmc.terrestria.biome;

import com.terraformersmc.terrestria.biome.builder.TerrestriaBiome;
import com.terraformersmc.terrestria.init.TerrestriaBiomes;
import com.terraformersmc.terrestria.init.TerrestriaFeatures;
import net.minecraft.class_1299;
import net.minecraft.class_1959;
import net.minecraft.class_2246;
import net.minecraft.class_3031;
import net.minecraft.class_3098;
import net.minecraft.class_3101;
import net.minecraft.class_3523;

import static com.terraformersmc.terrestria.biome.builder.DefaultFeature.*;

public class LushRedwoodForestBiomes {
	public static void register() {
		TerrestriaBiomes.LUSH_REDWOOD_CLEARING = TerrestriaBiomes.register("lush_redwood_clearing", TerrestriaBiome.builder()
				.configureSurfaceBuilder(class_3523.field_15701, class_3523.field_15677)
				.precipitation(class_1959.class_1963.field_9382).category(class_1959.class_1961.field_9361)
				.depth(1.2F)
				.scale(0.3F)
				.temperature(0.9F)
				.downfall(0.9F)
				.waterColor(4159204)
				.waterFogColor(329011)
				.addDefaultFeatures(LAND_CARVERS, STRUCTURES, LAKES, DUNGEONS, LARGE_FERNS, MINEABLES, ORES, DISKS,
						TAIGA_GRASS, DEFAULT_MUSHROOMS, DEFAULT_VEGETATION, SPRINGS, SWEET_BERRY_BUSHES_SNOWY,
						FROZEN_TOP_LAYER, DEFAULT_FLOWERS)
				.addTreeFeature(TerrestriaFeatures.FALLEN_REDWOOD_LOG, 1)
				.addTreeFeature(TerrestriaFeatures.FALLEN_HEMLOCK_LOG, 1)
				.addTreeFeature(TerrestriaFeatures.TINY_REDWOOD_TREE, 2)
				.addTreeFeature(TerrestriaFeatures.TINY_HEMLOCK_TREE, 2)
				.addGrassFeature(class_2246.field_10479.method_9564(), 4)
				.addGrassFeature(class_2246.field_10112.method_9564(), 12)
				.addStructureFeature(class_3031.field_13565)
				.addStructureFeature(class_3031.field_13547, new class_3101(0.004D, class_3098.class_3100.field_13692))
				.addDefaultSpawnEntries()
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6055, 8, 4, 4))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6140, 4, 2, 3))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_17943, 8, 2, 4))
				.build());

		TerrestriaBiomes.LUSH_REDWOOD_FOREST = TerrestriaBiomes.register("lush_redwood_forest", TerrestriaBiome.builder()
				.configureSurfaceBuilder(class_3523.field_15701, class_3523.field_15677)
				.precipitation(class_1959.class_1963.field_9382).category(class_1959.class_1961.field_9361)
				.depth(1.2F)
				.scale(0.3F)
				.temperature(0.9F)
				.downfall(0.9F)
				.waterColor(4159204)
				.waterFogColor(329011)
				.addDefaultFeatures(LAND_CARVERS, STRUCTURES, LAKES, DUNGEONS, LARGE_FERNS, MINEABLES, ORES, DISKS,
						TAIGA_GRASS, DEFAULT_MUSHROOMS, DEFAULT_VEGETATION, SPRINGS, SWEET_BERRY_BUSHES_SNOWY,
						FROZEN_TOP_LAYER, DEFAULT_FLOWERS)
				.addTreeFeature(TerrestriaFeatures.HEMLOCK_TREE, 4)
				.addTreeFeature(TerrestriaFeatures.MEGA_REDWOOD_TREE, 4)
				.addTreeFeature(TerrestriaFeatures.FALLEN_REDWOOD_LOG, 2)
				.addTreeFeature(TerrestriaFeatures.FALLEN_HEMLOCK_LOG, 2)
				.addTreeFeature(TerrestriaFeatures.TINY_REDWOOD_TREE, 2)
				.addTreeFeature(TerrestriaFeatures.TINY_HEMLOCK_TREE, 2)
				.addGrassFeature(class_2246.field_10479.method_9564(), 4)
				.addGrassFeature(class_2246.field_10112.method_9564(), 12)
				.addStructureFeature(class_3031.field_13565)
				.addStructureFeature(class_3031.field_13547, new class_3101(0.004D, class_3098.class_3100.field_13692))
				.addDefaultSpawnEntries()
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6055, 8, 4, 4))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6140, 4, 2, 3))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_17943, 8, 2, 4))
				.build());

		TerrestriaBiomes.LUSH_REDWOOD_FOREST_EDGE = TerrestriaBiomes.register("lush_redwood_forest_edge", TerrestriaBiome.builder()
				.configureSurfaceBuilder(class_3523.field_15701, class_3523.field_15677)
				.precipitation(class_1959.class_1963.field_9382).category(class_1959.class_1961.field_9361)
				.depth(1.2F)
				.scale(0.3F)
				.temperature(0.9F)
				.downfall(1.4F)
				.waterColor(4159204)
				.waterFogColor(329011)
				.addDefaultFeatures(LAND_CARVERS, STRUCTURES, LAKES, DUNGEONS, LARGE_FERNS, MINEABLES, ORES, DISKS,
						TAIGA_GRASS, DEFAULT_MUSHROOMS, DEFAULT_VEGETATION, SPRINGS, SWEET_BERRY_BUSHES_SNOWY,
						FROZEN_TOP_LAYER, DEFAULT_FLOWERS)
				.addTreeFeature(TerrestriaFeatures.HEMLOCK_TREE, 1)
				.addTreeFeature(TerrestriaFeatures.REDWOOD_TREE, 2)
				.addTreeFeature(TerrestriaFeatures.TINY_REDWOOD_TREE, 1)
				.addTreeFeature(TerrestriaFeatures.TINY_HEMLOCK_TREE, 2)
				.addGrassFeature(class_2246.field_10479.method_9564(), 4)
				.addGrassFeature(class_2246.field_10112.method_9564(), 12)
				.addStructureFeature(class_3031.field_13565)
				.addStructureFeature(class_3031.field_13547, new class_3101(0.004D, class_3098.class_3100.field_13692))
				.addDefaultSpawnEntries()
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6055, 8, 4, 4))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6140, 4, 2, 3))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_17943, 8, 2, 4))
				.build());
	}
}
