package com.terraformersmc.terrestria.biome;

import com.terraformersmc.terrestria.biome.builder.TerrestriaBiome;
import com.terraformersmc.terrestria.init.TerrestriaBiomes;
import com.terraformersmc.terrestria.init.TerrestriaFeatures;
import net.minecraft.class_1299;
import net.minecraft.class_1959;
import net.minecraft.class_3031;
import net.minecraft.class_3098;
import net.minecraft.class_3101;
import net.minecraft.class_3523;

import static com.terraformersmc.terrestria.biome.builder.DefaultFeature.*;
import static com.terraformersmc.terrestria.biome.builder.DefaultFeature.FROZEN_TOP_LAYER;

public class RainbowRainforestBiomes {
	public static void register() {
		TerrestriaBiomes.RAINBOW_RAINFOREST = TerrestriaBiomes.register("rainbow_rainforest", TerrestriaBiome.builder()
				.configureSurfaceBuilder(class_3523.field_15701, class_3523.field_15677)
				.precipitation(class_1959.class_1963.field_9382).category(class_1959.class_1961.field_9358)
				.depth(0.4F)
				.scale(0.4F)
				.temperature(0.95F)
				.downfall(0.9F)
				.waterColor(4159204)
				.waterFogColor(329011)
				.addDefaultFeatures(LAND_CARVERS, STRUCTURES, LAKES, DUNGEONS, MINEABLES, ORES, DISKS, DEFAULT_FLOWERS,
						JUNGLE_GRASS, DEFAULT_MUSHROOMS, DEFAULT_VEGETATION, SPRINGS, JUNGLE_VEGETATION, FROZEN_TOP_LAYER)
				.addStructureFeature(class_3031.field_13565)
				.addStructureFeature(class_3031.field_13586)
				.addStructureFeature(class_3031.field_13547, new class_3101(0.004D, class_3098.class_3100.field_13692))
				.addTreeFeature(TerrestriaFeatures.RAINBOW_EUCALYPTUS_TREE, 5)
				.addTreeFeature(class_3031.field_13529, 5)
				.addTreeFeature(TerrestriaFeatures.RUBBER_TREE, 3)
				.addDefaultSpawnEntries()
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6104, 40, 1, 2))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6081, 2, 1, 1))
				.build());

		TerrestriaBiomes.RAINBOW_RAINFOREST_MOUNTAINS = TerrestriaBiomes.register("rainbow_rainforest_mountains", TerrestriaBiome.builder()
				.configureSurfaceBuilder(class_3523.field_15701, class_3523.field_15677)
				.precipitation(class_1959.class_1963.field_9382).category(class_1959.class_1961.field_9358)
				.depth(1.0F)
				.scale(0.5F)
				.temperature(0.95F)
				.downfall(0.9F)
				.waterColor(4159204)
				.waterFogColor(329011)
				.addDefaultFeatures(LAND_CARVERS, STRUCTURES, LAKES, DUNGEONS, MINEABLES, ORES, DISKS, DEFAULT_FLOWERS,
						JUNGLE_GRASS, DEFAULT_MUSHROOMS, DEFAULT_VEGETATION, SPRINGS, JUNGLE_VEGETATION, FROZEN_TOP_LAYER)
				.addStructureFeature(class_3031.field_13565)
				.addStructureFeature(class_3031.field_13586)
				.addStructureFeature(class_3031.field_13547, new class_3101(0.004D, class_3098.class_3100.field_13692))
				.addTreeFeature(TerrestriaFeatures.RAINBOW_EUCALYPTUS_TREE, 5)
				.addTreeFeature(class_3031.field_13529, 5)
				.addTreeFeature(TerrestriaFeatures.RUBBER_TREE, 3)
				.addDefaultSpawnEntries()
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6104, 40, 1, 2))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6081, 2, 1, 1))
				.build());

		TerrestriaBiomes.RAINBOW_RAINFOREST_LAKE = TerrestriaBiomes.register("rainbow_rainforest_lake", TerrestriaBiome.builder()
				.configureSurfaceBuilder(class_3523.field_15701, class_3523.field_15677)
				.precipitation(class_1959.class_1963.field_9382).category(class_1959.class_1961.field_9358)
				.depth(-0.2F)
				.scale(0.0F)
				.temperature(0.95F)
				.downfall(0.9F)
				.waterColor(4159204)
				.waterFogColor(329011)
				.addDefaultFeatures(LAND_CARVERS, STRUCTURES, LAKES, DUNGEONS, MINEABLES, ORES, DISKS, DEFAULT_FLOWERS,
						JUNGLE_GRASS, DEFAULT_MUSHROOMS, DEFAULT_VEGETATION, SPRINGS, JUNGLE_VEGETATION, FROZEN_TOP_LAYER)
				.addStructureFeature(class_3031.field_13565)
				.addStructureFeature(class_3031.field_13586)
				.addStructureFeature(class_3031.field_13547, new class_3101(0.004D, class_3098.class_3100.field_13692))
				.addTreeFeature(TerrestriaFeatures.RAINBOW_EUCALYPTUS_TREE, 5)
				.addTreeFeature(class_3031.field_13529, 5)
				.addTreeFeature(TerrestriaFeatures.RUBBER_TREE, 3)
				.addDefaultSpawnEntries()
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6104, 40, 1, 2))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6081, 2, 1, 1))
				.build());
	}
}
