package com.terraformersmc.terrestria.biome;

import com.terraformersmc.terrestria.biome.builder.DefaultFeature;
import com.terraformersmc.terrestria.biome.builder.TerrestriaBiome;
import com.terraformersmc.terrestria.init.TerrestriaBiomes;
import com.terraformersmc.terrestria.init.TerrestriaFeatures;
import net.minecraft.class_1299;
import net.minecraft.class_1959;
import net.minecraft.class_3031;
import net.minecraft.class_3098;
import net.minecraft.class_3101;
import net.minecraft.class_3523;

public class SakuraForestBiomes {
	public static void register() {
		TerrestriaBiomes.SAKURA_FOREST = TerrestriaBiomes.register("sakura_forest", TerrestriaBiome.builder()
				.configureSurfaceBuilder(class_3523.field_15701, class_3523.field_15677)
				.precipitation(class_1959.class_1963.field_9382).category(class_1959.class_1961.field_9370)
				.depth(0.05F)
				.scale(0.1F)
				.temperature(0.8F)
				.downfall(1.0F)
				.waterColor(4159204)
				.waterFogColor(329011)
				.addDefaultFeatures(DefaultFeature.LAND_CARVERS, DefaultFeature.STRUCTURES, DefaultFeature.LAKES, DefaultFeature.DUNGEONS, DefaultFeature.MINEABLES, DefaultFeature.ORES, DefaultFeature.DEFAULT_MUSHROOMS,
						DefaultFeature.DEFAULT_VEGETATION, DefaultFeature.SPRINGS, DefaultFeature.FROZEN_TOP_LAYER)
				.addStructureFeature(class_3031.field_13565)
				.addStructureFeature(class_3031.field_13547, new class_3101(0.004D, class_3098.class_3100.field_13692))
				.addTreeFeature(TerrestriaFeatures.SAKURA_TREE, 6)
				.addTreeFeature(TerrestriaFeatures.JAPANESE_MAPLE_SHRUB, 4)
				.addDefaultSpawnEntries()
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6055, 5, 4, 4))
				.build());

		TerrestriaBiomes.WOODED_SAKURA_HILLS = TerrestriaBiomes.register("wooded_sakura_hills", TerrestriaBiome.builder()
				.configureSurfaceBuilder(class_3523.field_15701, class_3523.field_15677)
				.precipitation(class_1959.class_1963.field_9382).category(class_1959.class_1961.field_9370)
				.depth(0.4F)
				.scale(0.3F)
				.temperature(0.8F)
				.downfall(1.0F)
				.waterColor(4159204)
				.waterFogColor(329011)
				.addDefaultFeatures(DefaultFeature.LAND_CARVERS, DefaultFeature.STRUCTURES, DefaultFeature.LAKES, DefaultFeature.DUNGEONS, DefaultFeature.MINEABLES, DefaultFeature.ORES, DefaultFeature.DEFAULT_MUSHROOMS,
						DefaultFeature.DEFAULT_VEGETATION, DefaultFeature.SPRINGS, DefaultFeature.FROZEN_TOP_LAYER)
				.addStructureFeature(class_3031.field_13565)
				.addStructureFeature(class_3031.field_13547, new class_3101(0.004D, class_3098.class_3100.field_13692))
				.addTreeFeature(TerrestriaFeatures.SAKURA_TREE, 6)
				.addTreeFeature(TerrestriaFeatures.JAPANESE_MAPLE_SHRUB, 4)
				.addDefaultSpawnEntries()
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6055, 5, 4, 4))
				.build());
	}
}
