package com.terraformersmc.terrestria.biome;

import com.terraformersmc.terrestria.biome.builder.DefaultFeature;
import com.terraformersmc.terrestria.biome.builder.TerrestriaBiome;
import com.terraformersmc.terrestria.init.TerrestriaBiomes;
import com.terraformersmc.terrestria.init.TerrestriaBlocks;
import com.terraformersmc.terrestria.init.TerrestriaFeatures;
import com.terraformersmc.terrestria.init.TerrestriaSurfaces;
import net.minecraft.class_1299;
import net.minecraft.class_1959;
import net.minecraft.class_3031;
import net.minecraft.class_3098;
import net.minecraft.class_3101;

public class VolcanicIslandBiomes {
	public static void register() {
		TerrestriaBiomes.VOLCANIC_ISLAND = TerrestriaBiomes.register("volcanic_island", TerrestriaBiome.builder()
				.configureSurfaceBuilder(TerrestriaSurfaces.CLIFF, TerrestriaSurfaces.BASALT_CONFIG)
				.precipitation(class_1959.class_1963.field_9382).category(class_1959.class_1961.field_9357)
				.depth(0.1F)
				.scale(0.2F)
				.temperature(0.9F)
				.downfall(0.9F)
				.waterColor(0x54d3c0)
				.waterFogColor(0x24a0b0)
				.addDefaultFeatures(DefaultFeature.LAND_CARVERS, DefaultFeature.STRUCTURES, DefaultFeature.LAKES, DefaultFeature.DUNGEONS, DefaultFeature.MINEABLES, DefaultFeature.ORES, DefaultFeature.DISKS, DefaultFeature.DEFAULT_FLOWERS,
						DefaultFeature.DEFAULT_GRASS, DefaultFeature.DEFAULT_MUSHROOMS, DefaultFeature.DEFAULT_VEGETATION, DefaultFeature.SPRINGS, DefaultFeature.FROZEN_TOP_LAYER)
				.addStructureFeature(class_3031.field_13565)
				.addStructureFeature(class_3031.field_13547, new class_3101(0.004D, class_3098.class_3100.field_13692))
				.addGrassFeature(TerrestriaBlocks.INDIAN_PAINTBRUSH.method_9564(), 1)
				.addGrassFeature(TerrestriaBlocks.MONSTERAS.method_9564(), 4)
				.addTreeFeature(TerrestriaFeatures.JUNGLE_PALM_TREE, 5)
				.addDefaultSpawnEntries()
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6114, 3, 1, 4))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6073, 15, 3, 6))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6070, 15, 1, 5))
				.build());

		TerrestriaBiomes.VOLCANIC_ISLAND_SHORE = TerrestriaBiomes.register("volcanic_island_shore", TerrestriaBiome.builder()
				.configureSurfaceBuilder(TerrestriaSurfaces.CLIFF, TerrestriaSurfaces.BASALT_CONFIG)
				.precipitation(class_1959.class_1963.field_9382).category(class_1959.class_1961.field_9363)
				.depth(0.05F)
				.scale(0.05F)
				.temperature(0.9F)
				.downfall(0.9F)
				.waterColor(0x54d3c0)
				.waterFogColor(0x24a0b0)
				.addDefaultFeatures(DefaultFeature.LAND_CARVERS, DefaultFeature.STRUCTURES, DefaultFeature.LAKES, DefaultFeature.DUNGEONS, DefaultFeature.MINEABLES, DefaultFeature.ORES, DefaultFeature.DISKS, DefaultFeature.DEFAULT_FLOWERS,
						DefaultFeature.DEFAULT_GRASS, DefaultFeature.DEFAULT_MUSHROOMS, DefaultFeature.DEFAULT_VEGETATION, DefaultFeature.SPRINGS, DefaultFeature.FROZEN_TOP_LAYER)
				.addStructureFeature(class_3031.field_13565)
				.addStructureFeature(class_3031.field_13547, new class_3101(0.004D, class_3098.class_3100.field_13692))
				.addGrassFeature(TerrestriaBlocks.INDIAN_PAINTBRUSH.method_9564(), 1)
				.addGrassFeature(TerrestriaBlocks.MONSTERAS.method_9564(), 4)
				.addTreeFeature(TerrestriaFeatures.JUNGLE_PALM_TREE, 2)
				.addDefaultSpawnEntries()
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6114, 3, 1, 4))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6073, 15, 3, 6))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6070, 15, 1, 5))
				.build());

		TerrestriaBiomes.VOLCANIC_ISLAND_BEACH = TerrestriaBiomes.register("volcanic_island_beach", TerrestriaBiome.builder()
				.configureSurfaceBuilder(TerrestriaSurfaces.BASALT_BEACH, TerrestriaSurfaces.BASALT_CONFIG)
				.precipitation(class_1959.class_1963.field_9382).category(class_1959.class_1961.field_9363)
				.depth(0F)
				.scale(0.05F)
				.temperature(0.9F)
				.downfall(0.9F)
				.waterColor(0x54d3c0)
				.waterFogColor(0x24a0b0)
				.addDefaultFeatures(DefaultFeature.LAND_CARVERS, DefaultFeature.STRUCTURES, DefaultFeature.LAKES, DefaultFeature.DUNGEONS, DefaultFeature.MINEABLES, DefaultFeature.ORES, DefaultFeature.DISKS, DefaultFeature.DEFAULT_FLOWERS,
						DefaultFeature.DEFAULT_GRASS, DefaultFeature.DEFAULT_MUSHROOMS, DefaultFeature.DEFAULT_VEGETATION, DefaultFeature.SPRINGS, DefaultFeature.FROZEN_TOP_LAYER)
				.addStructureFeature(class_3031.field_13565)
				.addStructureFeature(class_3031.field_13547, new class_3101(0.004D, class_3098.class_3100.field_13692))
				.addGrassFeature(TerrestriaBlocks.INDIAN_PAINTBRUSH.method_9564(), 1)
				.addGrassFeature(TerrestriaBlocks.MONSTERAS.method_9564(), 4)
				.addTreeFeature(TerrestriaFeatures.JUNGLE_PALM_TREE, 2)
				.addDefaultSpawnEntries()
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6114, 3, 1, 4))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6073, 15, 3, 6))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6070, 15, 1, 5))
				.build());
	}
}
