package com.terraformersmc.terrestria.biome.builder;

import net.minecraft.class_1959;
import net.minecraft.class_3504;
import net.minecraft.class_3523;
import net.minecraft.class_3531;

public class BuilderBiomeSettings extends class_1959.class_1960 implements Cloneable {
	private class_3504<?> surfaceBuilder;
	private class_1959.class_1963 precipitation;
	private class_1959.class_1961 category;
	private Float depth;
	private Float scale;
	private Float temperature;
	private Float downfall;
	private Integer waterColor;
	private Integer waterFogColor;
	private String parent;

	public BuilderBiomeSettings() {
		super();
	}

	public BuilderBiomeSettings(BuilderBiomeSettings existing) {
		if(existing.surfaceBuilder != null) {
			this.surfaceBuilder(existing.surfaceBuilder);
		}

		if(existing.precipitation != null) {
			this.precipitation(existing.precipitation);
		}

		if(existing.category != null) {
			this.category(existing.category);
		}

		if(existing.depth != null) {
			this.depth(existing.depth);
		}

		if(existing.scale != null) {
			this.scale(existing.scale);
		}

		if(existing.temperature != null) {
			this.temperature(existing.temperature);
		}

		if(existing.downfall != null) {
			this.downfall(existing.downfall);
		}

		if(existing.waterColor != null) {
			this.waterColor(existing.waterColor);
		}

		if(existing.waterFogColor != null) {
			this.waterFogColor(existing.waterFogColor);
		}

		if(existing.parent != null) {
			this.parent(existing.parent);
		}
	}

	@Override
	public <SC extends class_3531> BuilderBiomeSettings configureSurfaceBuilder(class_3523<SC> builder, SC config) {
		this.surfaceBuilder = new class_3504(builder, config);
		super.method_8737(builder, config);

		return this;
	}

	@Override
	public BuilderBiomeSettings surfaceBuilder(class_3504<?> surfaceBuilder) {
		this.surfaceBuilder = surfaceBuilder;
		super.method_8731(surfaceBuilder);

		return this;
	}

	@Override
	public BuilderBiomeSettings precipitation(class_1959.class_1963 precipitation) {
		this.precipitation = precipitation;
		super.method_8735(precipitation);

		return this;
	}

	@Override
	public BuilderBiomeSettings category(class_1959.class_1961 category) {
		this.category = category;
		super.method_8738(category);

		return this;
	}

	@Override
	public BuilderBiomeSettings depth(float depth) {
		this.depth = depth;
		super.method_8740(depth);

		return this;
	}

	@Override
	public BuilderBiomeSettings scale(float scale) {
		this.scale = scale;
		super.method_8743(scale);

		return this;
	}

	@Override
	public BuilderBiomeSettings temperature(float temperature) {
		this.temperature = temperature;
		super.method_8747(temperature);

		return this;
	}

	@Override
	public BuilderBiomeSettings downfall(float downfall) {
		this.downfall = downfall;
		super.method_8727(downfall);

		return this;
	}

	@Override
	public BuilderBiomeSettings waterColor(int color) {
		this.waterColor = color;
		super.method_8733(waterColor);

		return this;
	}

	@Override
	public BuilderBiomeSettings waterFogColor(int color) {
		this.waterFogColor = color;
		super.method_8728(waterFogColor);

		return this;
	}

	@Override
	public BuilderBiomeSettings parent(String parent) {
		this.parent = parent;
		super.method_8745(parent);

		return this;
	}
}
