package com.terraformersmc.terrestria.command;

import com.mojang.brigadier.builder.LiteralArgumentBuilder;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
import net.fabricmc.fabric.api.registry.CommandRegistry;
import net.minecraft.class_124;
import net.minecraft.class_2168;
import net.minecraft.class_2170;
import net.minecraft.class_2338;
import net.minecraft.class_2558;
import net.minecraft.class_2561;
import net.minecraft.class_2564;
import net.minecraft.class_2568;
import net.minecraft.class_2588;
import net.minecraft.class_3031;
import net.minecraft.class_3532;
import net.minecraft.text.*;

/**
 * Extended version of /locate to locate any structure
 */
public class LocateAny {
	private static final SimpleCommandExceptionType FAILED_EXCEPTION = new SimpleCommandExceptionType(new class_2588("commands.locate.failed"));

	public static void register() {
		CommandRegistry.INSTANCE.register(false, dispatcher -> {
			LiteralArgumentBuilder<class_2168> builder = class_2170.method_9247("locateany").requires(source ->
					source.method_9259(2));
			class_3031.field_13557.keySet().forEach(structure -> builder.then(class_2170.method_9247(structure)
					.executes(context -> execute(context.getSource(), structure))));
			dispatcher.register(builder);
		});
	}

	private static int execute(class_2168 source, String structure) throws CommandSyntaxException {
		class_2338 position = new class_2338(source.method_9222());
		class_2338 found = source.method_9225().method_8487(structure, position, 100, false);
		if (found == null) {
			throw FAILED_EXCEPTION.create();
		} else {
			int blockDistance = class_3532.method_15357(getDistance(position.method_10263(), position.method_10260(), found.method_10263(), found.method_10260()));
			class_2561 component_1 = class_2564.method_10885(new class_2588("chat.coordinates", found.method_10263(), "~", found.method_10260())).method_10859((style_1) ->
					style_1.method_10977(class_124.field_1060).method_10958(new class_2558(class_2558.class_2559.field_11745, "/tp @s " + found.method_10263() + " ~ " + found.method_10260())).method_10949(new class_2568(class_2568.class_2569.field_11762, new class_2588("chat.coordinates.tooltip")))
			);
			source.method_9226(new class_2588("commands.locate.success", structure, component_1, blockDistance), false);
			return blockDistance;
		}
	}

	private static double getDistance(int posX, int posZ, int biomeX, int biomeZ) {
		return class_3532.method_15368(Math.pow(biomeX - posX, 2) + Math.pow(biomeZ - posZ, 2));
	}
}