package com.terraformersmc.terrestria.feature.trees.templates;

import com.mojang.datafixers.Dynamic;
import com.terraformersmc.terraform.block.LeafPileBlock;
import com.terraformersmc.terrestria.feature.TreeDefinition;
import java.util.Random;
import java.util.Set;
import java.util.function.Function;
import net.minecraft.class_2338;
import net.minecraft.class_2902;
import net.minecraft.class_2944;
import net.minecraft.class_3111;
import net.minecraft.class_3341;
import net.minecraft.class_3747;

public class ShrubFeature extends class_2944<class_3111> {
	private TreeDefinition.Basic tree;

	public ShrubFeature(Function<Dynamic<?>, ? extends class_3111> function, boolean notify, TreeDefinition.Basic tree) {
		super(function, notify);
		this.tree = tree;
	}

	public ShrubFeature sapling() {
		return new ShrubFeature(class_3111::method_13565, true, tree);
	}

	public boolean method_12775(Set<class_2338> blocks, class_3747 world, Random rand, class_2338 pos, class_3341 boundingBox) {
		pos = world.method_8598(class_2902.class_2903.field_13203, pos).method_10074();

		if (method_16430(world, pos)) {
			pos = pos.method_10084();
			this.method_12773(blocks, world, pos, this.tree.getLog(), boundingBox);

			for (int y = pos.method_10264(); y <= pos.method_10264() + 2; ++y) {
				int dY = y - pos.method_10264();
				int radius = 2 - dY;

				for (int x = pos.method_10263() - radius; x <= pos.method_10263() + radius; ++x) {
					int dX = x - pos.method_10263();

					for (int z = pos.method_10260() - radius; z <= pos.method_10260() + radius; ++z) {
						int dZ = z - pos.method_10260();

						if (Math.abs(dX) != radius || Math.abs(dZ) != radius || rand.nextInt(2) != 0) {
							class_2338 candidate = new class_2338(x, y, z);

							if (method_16420(world, candidate) || world.method_16358(candidate, state -> state.method_11614() instanceof LeafPileBlock)) {
								this.method_12773(blocks, world, candidate, this.tree.getLeaves(), boundingBox);
							}
						}
					}
				}
			}
		}

		return true;
	}
}